]> git.pld-linux.org Git - packages/rpm.git/blob - rpm.macros
- use less global variables (better flow control)
[packages/rpm.git] / rpm.macros
1 # $Revision$, $Date$
2 # PLD Linux rpm macros
3
4 %epoch          0
5 %x8664          x86_64 amd64 ia32e
6
7 # kernel compiler
8 %kgcc           %{__cc}
9 %kgcc_package   gcc
10
11 # compiler version
12 %cc_version     %{expand:%%global cc_version %(%{__cc} -dumpversion || echo ERROR)}%cc_version
13 %cxx_version    %{expand:%%global cxx_version %(%{__cxx} -dumpversion || echo ERROR)}%cxx_version
14
15 %__rm           /bin/rm --interactive=never
16
17 # Build system path macros.
18 %__autoconf     autoconf %{?debug:-Wall}
19 %__automake     automake -a -c -f --foreign
20 %__autopoint    autopoint --force
21
22 # add parallel build flags: -jN
23 #
24 # if you want to disable parallel build do (replace %% with %)
25 # echo '%%_smp_mflags %%{nil}' >> ~/.rpmmacros
26 #
27 %__make         make %{?_smp_mflags}
28 %__scons        scons %{?_smp_mflags}
29 %__waf          waf %{?_smp_mflags}
30 %__cmake        cmake %{?_smp_mflags}
31
32 %_smp_mflags %(_NCPUS=$(/usr/bin/getconf _NPROCESSORS_ONLN); \\\
33                                 [ "$_NCPUS" -gt 1 ] && echo "-j$(($_NCPUS * 2))")
34
35 %__gettextize { \
36         if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
37                 gettextize --copy --force --no-changelog; \
38         else \
39                 gettextize --copy --force --no-changelog --intl; \
40         fi; \
41         if [ ! -f po/Makevars ]; then \
42                 cp -f po/Makevars{.template,}; \
43         fi; \
44 }
45
46 %__glib_gettextize      glib-gettextize --copy --force
47 %__gnome_doc_common     gnome-doc-common --copy
48 %__gnome_doc_prepare    gnome-doc-prepare --copy --force
49 %__gtkdocize            gtkdocize --copy
50 %__intltoolize          intltoolize --copy --force
51 %__libtoolize           libtoolize --copy --force --install
52
53 #       Path to top of build area.
54 %_topdir                %{expand:%%global _topdir %(test -d ../SPECS -a -d ../SOURCES && (cd ..; pwd) || echo $HOME/rpm)}%_topdir
55
56 #       The number of cvs changelog entries kept when building package.
57 %_buildchangelogtruncate 20
58
59 %dependencytracking     %{nil}
60
61 #       Relations between package names that cause dependency loops
62 #       with legacy packages that cannot be fixed. Relations are
63 #       specified as
64 #               p>q
65 #       where package p has a Requires: on something that package q Provides:
66 #
67 # XXX   Note: that there cannot be any whitespace within the string "p>q",
68 #       and that both p and q are package names (i.e. no version/release).
69 %_dependency_whiteout   %{nil}
70
71 #-----------------------------------------------------------------
72 #
73 # (re)definition of %{rpm*flags} with %filterout_* support
74 # BuildRequires:        awk
75 # BuildRequires:        rpmbuild(macros) >= 1.315
76 #
77 # Flags specified in %filterout_* are removed from %rpm*flags, exactly:
78 # %rpmcflags    = %optflags - %filterout - %filterout_c   - %filterout_ld
79 # %rpmcxxflags  = %optflags - %filterout - %filterout_cxx - %filterout_ld
80 # %rpmcppflags  = %optcppflags - %filterout - %filterout_cpp - %filterout_ld
81 # %rpmldflags   = %optldflags - %filterout_ld
82 #
83 # Regular expressions are supported, but to avoid some character be treated
84 # as regular expression it must be escaped twice.
85
86 %filter_out                                             \
87         for (i = 1; i in I; i++) {      A=0;    \
88                 for (f in F) {                          \
89                         if (I[i] ~ "^" F[f] "$") A=1;   \
90                 };                                                      \
91                 if (!A) printf(I[i] FS);        \
92         }
93
94 %rpmcflags %(awk 'BEGIN {
95         split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
96         split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
97         %{filter_out}
98 }')
99
100 %rpmcxxflags %(awk 'BEGIN {
101         split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
102         split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
103         %{filter_out}
104 }')
105
106 %rpmcppflags %(awk 'BEGIN {
107         split("%{?debug:%debugcppflags}%{!?debug:%optcppflags}%{?debuginfocppflags}",I);
108         split("%{?filterout} %{?filterout_cpp} %{?filterout_cpp}",F);
109         %{filter_out}
110 }')
111
112 %rpmldflags %(awk 'BEGIN {
113         split("%{?optldflags}",I);
114         split("%{?filterout_ld}",F)
115         %{filter_out}
116 }')
117
118 # rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
119 # but, don't use it, better use gcc as linker
120 %ld_rpmldflags %(awk 'BEGIN {
121         split("%{rpmldflags}",F);
122         for (f in F) {
123                 s = F[f];
124                 if (s ~ /^-Wl,/) {
125                         s = substr(s,5);
126                         gsub(/,/," ",s);
127                 };
128                 printf(s FS);
129         };
130 }')
131
132 #-----------------------------------------------------------------
133 #
134 #  Generate a command which cleans environment, leaving only the
135 # most important variables.
136 #  If any spec requires any additional environment it should
137 # redefine %_preserve_env in following manner:
138 #
139 #       # ADDITIONAL_VAR is required because [a good reason here]
140 #       %define _preserve_env ADDITIONAL_VAR
141
142 %_preserve_env_base     PATH HOME TMP TMPDIR SSH_AUTH_SOCK
143
144 %_clean_env             \
145         %{!?_preserve_env:%global _preserve_env %{nil}}%{expand:%%global _preserve_env %{_preserve_env} %_preserve_env_base} \
146         env -i %(awk -vq="'" -vqq="\\"'\\"" -vq2q="'\\"'" 'BEGIN {
147         split("%{?_preserve_env}", P);
148         for (i in P) {
149                 p = P[i];
150                 if (!ENVIRON[p] || d[p]) {
151                         continue;
152                 }
153                 d[p] = 1;
154                 split(ENVIRON[p], V, "");
155                 val = p "=";
156                 for (j = 1; j in V; j++) {
157                         v = V[j];
158                         if (v == q)
159                                 v = qq;
160                         else if (v == "\\"")
161                                 v = q2q;
162                         else if (v == "\\\\")
163                                 v = "\\\\\\\\";
164                         else
165                                 gsub("[^a-zA-Z0-9/:._-]", "\\"&\\"", v);
166                         val = val "" v;
167                 }
168                 printf(val " ");
169         }
170 }')
171
172 #-----------------------------------------------------------------
173 %configure2_13 { \
174  if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
175  LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
176  CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
177  CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
178  FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
179  FCFLAGS="${FCFLAGS:-%rpmcflags}" ; export FCFLAGS ; \
180  CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" ; export CPPFLAGS ; \
181  %{?__cc:CC="%{__cc}" ; export CC ; } \
182  %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
183  %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
184         --host=%{_target_platform} \
185         --prefix=%{_prefix} \
186         --exec-prefix=%{_exec_prefix} \
187         --bindir=%{_bindir} \
188         --sbindir=%{_sbindir} \
189         --sysconfdir=%{_sysconfdir} \
190         --datadir=%{_datadir} \
191         --includedir=%{_includedir} \
192         --libdir=%{_libdir} \
193         --libexecdir=%{_libexecdir} \
194         --localstatedir=%{_localstatedir} \
195         --sharedstatedir=%{_sharedstatedir} \
196         --mandir=%{_mandir} \
197         --infodir=%{_infodir} \
198         --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
199         %{dependencytracking} \
200 }
201
202 %__cmake        /usr/bin/cmake
203 %cmake { \
204 CC="%{__cc}" \
205 CXX="%{__cxx}" \
206 CFLAGS="%{rpmcflags}" \
207 CXXFLAGS="%{rpmcxxflags}" \
208 LDFLAGS="%{rpmldflags}" \
209 %{__cmake} \
210 }
211
212 # override __scons to add -j4 in your ~/.rpmmacros for parallel make
213 %__scons        /usr/bin/scons
214 %scons { \
215 %{__scons} \
216         LDFLAGS="${LDFLAGS:-%rpmldflags}" \
217         CFLAGS="${CFLAGS:-%rpmcflags}" \
218         CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
219         FFLAGS="${FFLAGS:-%rpmcflags}" \
220         CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
221         %{?__cc:CC="%{__cc}"} \
222         %{?__cxx:CXX="%{__cxx}"} \
223         libsuffix=%{_lib} \
224         prefix=%{_prefix} \
225 }
226
227 # waf. see waf.spec
228 # override __waf to add -j4 in your ~/.rpmmacros for parallel make
229 %__waf  /usr/bin/waf
230 %waf { \
231 CC="%{__cc}" \
232 CXX="%{__cxx}" \
233 CPP="%{__cpp}" \
234 CFLAGS="%{rpmcflags}" \
235 CXXFLAGS="%{rpmcxxflags}" \
236 %{__waf} \
237 }
238
239 #----------------------------------------------------------------
240 #%configure_cache 0
241 %configure_cache_file   %{buildroot}.configure.cache
242
243 %configure {./configure \
244         LDFLAGS="${LDFLAGS:-%rpmldflags}" \
245         CFLAGS="${CFLAGS:-%rpmcflags}" \
246         CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
247         FFLAGS="${FFLAGS:-%rpmcflags}" \
248         FCFLAGS="${FCFLAGS:-%rpmcflags}" \
249         CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
250         %{?__cc:CC="%{__cc}"} \
251         %{?__cxx:CXX="%{__cxx}"} \
252         --host=%{_target_platform} \
253         --build=%{_target_platform} \
254         --prefix=%{_prefix} \
255         --exec-prefix=%{_exec_prefix} \
256         --bindir=%{_bindir} \
257         --sbindir=%{_sbindir} \
258         --sysconfdir=%{_sysconfdir} \
259         --datadir=%{_datadir} \
260         --includedir=%{_includedir} \
261         --libdir=%{_libdir} \
262         --libexecdir=%{_libexecdir} \
263         --localstatedir=%{_localstatedir} \
264         --sharedstatedir=%{_sharedstatedir} \
265         --mandir=%{_mandir} \
266         --infodir=%{_infodir} \
267         --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
268         %{dependencytracking} \
269         %{?configure_cache:--cache-file=%{configure_cache_file}} \
270 }
271
272 # overload to insert debuginfo package
273 %prep \
274 %if 0%{?_enable_debug_packages}\
275 %{debug_package}\
276 %endif\
277 %%prep\
278 %{nil}
279
280 # Location of autoconf macros
281 %_aclocaldir    %{expand:%%global _aclocaldir %(aclocal --print-ac-dir || echo ERROR)}%_aclocaldir
282
283 # Location of omf files
284 %_omf_dest_dir  %{expand:%%global _omf_dest_dir %(scrollkeeper-config --omfdir || echo ERROR)}%_omf_dest_dir
285
286 # Location of pkgconfig files
287 %_pkgconfigdir  /usr/%{_lib}/pkgconfig
288 # noarch pkgconfig files
289 %_npkgconfigdir /usr/share/pkgconfig
290
291 # Location of desktop files
292 %_desktopdir    /usr/share/applications
293 %_applnkdir     ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
294
295 # Location of pixmaps for applnk/desktop files
296 %_pixmapsdir    /usr/share/pixmaps
297
298 # Location of themable icons for applnk/desktop files
299 %_iconsdir      /usr/share/icons
300
301 # Location of fonts directories
302 %_fontsdir      /usr/share/fonts
303
304 # Location of Gtk and associated libraries documentation
305 %_gtkdocdir     %{_defaultdocdir}/gtk-doc/html
306
307 # Location of KDE documentation
308 %_kdedocdir     %{_defaultdocdir}/kde/HTML
309
310 # unsermake script
311 %__unsermake /usr/share/unsermake/unsermake
312
313 # Current date
314 %date           %(LC_ALL=C date +"%a %b %d %Y")
315
316 # Example files, programs, scripts...
317 %_examplesdir   /usr/src/examples
318
319 # Alternative kernel type/version
320 %_alt_kernel    %{nil}%{?alt_kernel:-%{?alt_kernel}}
321
322 # The directory holding Linux kernel sources
323 %_kernelsrcdir  /usr/src/linux%{_alt_kernel}
324
325 # If non-empty "debug" macro defined, add "dbg" suffix to release number
326 %_rpmfilename           %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
327
328
329 %releq_kernel                   %{expand:%%global releq_kernel %(R=$(LC_ALL=C rpm -q --qf '%{N} = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel
330 %releq_kernel_up                %{expand:%%global releq_kernel_up %(R=$(LC_ALL=C rpm -q --qf '%{N}-up = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_up
331 %releq_kernel_smp()             %{expand:%%global releq_kernel_smp %(R=$(LC_ALL=C rpm -q --qf '%{N}-smp = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_smp
332 %requires_releq_kernel(s:)              Requires%{-s:(%{-s*})}: %releq_kernel
333 %requires_releq_kernel_up(s:)   Requires%{-s:(%{-s*})}: %releq_kernel_up
334 %requires_releq_kernel_smp(s:)  Requires%{-s:(%{-s*})}: %releq_kernel_smp
335
336 # Requires name = version-release
337 %requires_releq()       %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_eq_to -r %1 %1}}}
338 # Requires: name = version
339 %requires_eq()          %{!?1:ERROR}%{?2:ERROR}%{?1:%{!?2:%{expand:%%requires_eq_to %1 %1}}}
340 # Requires: name = version (version based on querying package %2)
341 %requires_eq_to(r)      %{!?2:ERROR}%{?3:ERROR}%{?2:%{!?3:%(if ! LC_ALL=C rpm -q --qf 'Requires: %1 = %|E?{%{E}:}|%{V}%{?-r:-%{R}}\\n' %2 | grep '^Requires:'; then echo "BuildRequires: %2"; fi)}}
342
343 %apache_modules_api %{expand:%%global apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)}%apache_modules_api
344
345 # kernel version-release handling
346 %__kernel_ver    %{expand:%%global __kernel_ver %( \\
347         Z=$(awk -F'"' '/UTS_RELEASE/{print $2}' %{_kernelsrcdir}/include/linux/{version,utsrelease}.h 2>/dev/null); \\
348         Z=${Z:-$(awk -F' = ' '/^VERSION/{v=$2} /^PATCHLEVEL/{p=$2} /^SUBLEVEL/{s=$2} /^EXTRAVERSION/{e=$2} END {printf("%d.%d.%d%s", v, p, s, e)}' %{_kernelsrcdir}/Makefile 2>/dev/null)}; \\
349         echo ${Z:-ERROR}; \\
350 )}%__kernel_ver
351
352 %__kernel_rel   %{expand:%%global __kernel_rel %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rel
353 %__kernel_rpmvr %{expand:%%global __kernel_rpmvr %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{V}-%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rpmvr
354 %_kernel_ver    %{expand:%%global _kernel_ver %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}}%_kernel_ver
355 %_kernel_ver_str %{expand:%%global _kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')}%_kernel_ver_str
356
357 # `uname -r` to be used in @release field
358 %_kernel_vermagic       %{expand:%%global _kernel_vermagic %(echo %{_kernel_ver} | sed -e 's/-/_/g')}%_kernel_vermagic
359
360 # sgml macros
361 %xmlcat_add()           /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
362 %xmlcat_del()           /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
363 %xmlcat_add_rewrite     /usr/bin/xmlcatalog --noout --add rewriteSystem
364 %xmlcat_create()        /usr/bin/xmlcatalog --noout --create %1 ;
365 %sgmlcat_add()          /usr/bin/install-catalog --add %1 %2 > /dev/null ;
366 %sgmlcat_del()          /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
367 %docbook_sgmlcat_fix() { for l in \
368 '' \
369 '  -- default decl --' \
370 'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
371 '  -- hacks for opensp --' \
372 'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
373 'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd"                  "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
374 '' \
375 ; do echo $l; done >> %1 \
376 }
377
378 # vim - "
379
380 # minimum file size needed for compressed documents.
381 # just smaller files than this get larger when compressed.
382 # some stats:
383 # - 0 byte file compressed was 25 bytes .gz
384 # - 39 byte file was compressed as 57
385 # - with test/test.spec@man 158 byte file was compressed also 158
386 %_min_compress_bytes    159
387
388 #-----------------------------------------------------------------
389 # find and gzip all files in %{_mandir} and %{infodir}
390 #
391 # Requires: xargs, find
392 #
393 #%no_install_post_compress_docs 1
394 %__spec_install_post_compress_docs { \
395 %{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
396         for i in /usr/share/man /usr/X11R6/man; do \
397                 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
398                         echo "Compress man pages: $i"; \
399                         find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
400                         find "$RPM_BUILD_ROOT$i" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
401                         find $RPM_BUILD_ROOT$i -type l | while read a; do \
402                                 m=$(readlink $a); \
403                                 rm -f $a; \
404                                 echo .so ${m##*/} > $a; \
405                                 echo >&2 "Converted ${a#$RPM_BUILD_ROOT} from symlink to man link: ${m##*/}"; \
406                         done; \
407                         find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
408                 fi; \
409         done; \
410         if [ -d "$RPM_BUILD_ROOT%{_infodir}" ]; then \
411                 echo "Compress info pages: %{_infodir}"; \
412                 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
413                 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
414                 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.info*' -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
415         fi; \
416 }; __spec_install_post_compress_docs } }
417
418 #-----------------------------------------------------------------
419 # Strip executable binaries and shared object files
420 #
421 # Requires: find, awk, strip, cut, xargs
422 #
423 # Special macros which affect this process:
424 #%no_install_post_strip 1               # disable stripping at all
425 #%_noautostrip                  regexp  # exclude files matching (anchored!) regex from stripping
426 #%_autostripall                 regexp  # strip files matching (anchored!) regex using plain strip
427 #%_autostripunneeded    regexp  # strip files matching (anchored!) regex using strip --strip-unneeded
428 #%_autostripdebug               regexp  # strip files matching (anchored!) regex using strip --strip-debug
429 #
430 %__spec_install_post_strip {%{!?debug: \
431 %{!?no_install_post_strip:__spec_install_post_strip() { \
432 if [ -d "$RPM_BUILD_ROOT" ]; then \
433         if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
434                 modulelist=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
435                 if [ "$modulelist" ]; then \
436                         modulecount=$(echo "$modulelist" | wc -l); \
437                         printf "Stripping %d kernel modules..." $modulecount; \
438                         echo "$modulelist" | xargs -l512 chmod u+w; \
439                         echo "$modulelist" | xargs -l512 %{__strip} --strip-unneeded --remove-section=.comment --remove-section=.note.GNU-stack; \
440                         echo "DONE"; \
441                 fi; \
442         fi; \
443         filelist=$(find $RPM_BUILD_ROOT -type f ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautostrip:! -regex "%{_noautostrip}"} %{?_autostripall:! -regex "%{_autostripall}"} %{?_autostripunneeded:! -regex "%{_autostripunneeded}"} %{?_autostripdebug:! -regex "%{_autostripdebug}"}); \
444         if [ -n "$filelist" ]; then \
445                 filetypes=`echo "$filelist" | xargs -r -d'\\n' file`; \
446                 elfexelist=`echo "$filetypes" | awk -F: '/ELF.*executable/ {print $1}'`; \
447                 elfsharedlist=`echo "$filetypes" | awk -F: '/LF.*shared object/ {print $1}'`; \
448                 archiveslist=`echo "$filetypes" | awk -F: '/current ar archive/ {print $1}'`; \
449                 if [ -n "$elfexelist" ]; then \
450                         printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
451                         chmod u+w $elfexelist; \
452                         %{__strip} --remove-section=.note --remove-section=.comment $elfexelist; \
453                         echo "DONE"; \
454                 fi; \
455                 if [ -n "$elfsharedlist" ]; then \
456                         printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
457                         chmod u+w $elfsharedlist; \
458                         %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $elfsharedlist; \
459                         echo "DONE"; \
460                 fi; \
461                 if [ -n "$archiveslist" ]; then \
462                         printf "Stripping %d ar archives..." $(echo "$archiveslist" | wc -l); \
463                         chmod u+w $archiveslist; \
464                         %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $archiveslist; \
465                         echo "DONE"; \
466                 fi; \
467         fi; \
468     filelist_all=%{?_autostripall:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripall}")}; \
469     filelist_unneeded=%{?_autostripunneeded:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripunneeded}")}; \
470     filelist_debug=%{?_autostripdebug:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripdebug}")}; \
471         if [ -n "$filelist_all" ]; then \
472                 printf "Stripping everything from %d additional files..." $(echo "$filelist_all" | wc -l); \
473                 chmod u+w $filelist_all; \
474                 %{__strip} --remove-section=.note --remove-section=.comment $filelist_all; \
475                 echo "DONE"; \
476         fi; \
477         if [ -n "$filelist_unneeded" ]; then \
478                 printf "Stripping unneeded from %d additional files..." $(echo "$filelist_unneeded" | wc -l); \
479                 chmod u+w $filelist_unneeded; \
480                 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $filelist_unneeded; \
481                 echo "DONE"; \
482         fi; \
483         if [ -n "$filelist_debug" ]; then \
484                 printf "Stripping debuginfo from %d additional files..." $(echo "$filelist_debug" | wc -l); \
485                 chmod u+w $filelist_debug; \
486                 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $filelist_debug; \
487                 echo "DONE"; \
488         fi; \
489 fi; }; __spec_install_post_strip } } }
490
491 #-----------------------------------------------------------------
492 # remove all RPATH from executable binaries and shared object files
493 #
494 # Requires: find, awk, cut, xargs, chrpath, uname
495 #
496 # Special macros which affect this process
497 #%no_install_post_chrpath       1       # disable chrpath at all
498 #%_noautochrpath        regex           # exclude files matching (anchored!) regex from chrpath
499 #
500 %__spec_install_post_chrpath {%{!?debug: \
501 %{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
502 if [ -d "$RPM_BUILD_ROOT" ]; then \
503         files=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautochrpath:! -regex "%{_noautochrpath}"}`; \
504         if [ -n "$files" ]; then \
505                 objs=`echo "$files" | xargs -r -d'\\n' file | awk -F: '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}'`; \
506         fi; \
507         if [ -n "$objs" ]; then \
508                 printf "Remove RPATH from %d executable binaries and shared object files.\n" $(echo "$objs" | wc -l); \
509                 echo "$objs" | \
510                 while read file; do \
511                         rpath= ; \
512                         chmod u+w "$file"; \
513                         for dir in $(chrpath -l "$file" | awk '/RPATH=/ { gsub(/.*RPATH=/,""); gsub(/:/," "); print $0 }'); do \
514                                         case $dir in \
515                                         '$ORIGIN' ) \
516                                                 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
517                                                 else rpath="$rpath:$dir" ; fi ; \
518                                                 continue ; \
519                                                 ;; \
520                                         esac ; \
521                                         newdir=$(readlink -m "$dir"); \
522                                         [ ${#newdir} -le ${#dir} ] && dir=$newdir; \
523                                         case $dir in \
524                                         /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
525                                                 echo "remove-rpath: $dir in $file"; \
526                                                 ;; \
527                                         * ) \
528                                                 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
529                                                 else rpath="$rpath:$dir" ; fi ; \
530                                                 ;; \
531                                         esac ; \
532                         done ; \
533                         if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
534                         else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
535                 done; \
536         fi; \
537 fi; }; __spec_install_post_chrpath } } }
538
539 #-----------------------------------------------------------------
540 # Find all shared object files with unresolved symbols. Warn
541 # and terminate if any found (termination can be turned off by define).
542 #%no_install_post_check_so 1
543 %__spec_install_post_check_so { \
544  __spec_install_post_check_so() { \
545     fail=0; \
546     printf "Searching for shared objects with unresolved symbols..."; \
547     for f in $(find $RPM_BUILD_ROOT -type f -name '*.so.*' -print); do \
548         LC_ALL=C objdump -T $f 2> /dev/null | LC_ALL=C awk -v "file=$f" 'BEGIN { found=0; skip["program_name"]=1; symbols = "" } /^[0-9a-z]+ +D +\*UND\*/ { if ($NF in skip) { next; }; found = 1; symbols = symbols "\n\t" $NF } END { if (found) { print "\nUnresolved symbols found in: " file symbols; exit(1); } } ' || fail=1 ; \
549     done ; \
550     echo " DONE"; \
551     %{!?no_install_post_check_so:[ $fail -eq 1 ] && : || :;} \
552 }; __spec_install_post_check_so }}
553
554 #-----------------------------------------------------------------
555 # Find and gzip all kernel modules
556 #
557 # Requires: find
558 #
559 #%no_install_post_compress_modules      1
560 %__spec_install_post_compress_modules { \
561 %{!?no_install_post_compress_modules: __spec_install_post_compress_modules() { \
562         if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
563                 q=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
564                 if [ "$q" ]; then \
565                         printf "Compress %d kernel modules..." $(echo "$q" | wc -l); \
566                         echo "$q" | xargs -r %{__gzip} -9nf; \
567                         echo "DONE"; \
568                         find $RPM_BUILD_ROOT/lib/modules -name '*o' -type l -printf "%p %l\n" | \
569                         while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
570                 fi; \
571         fi; \
572 }; __spec_install_post_compress_modules } }
573
574 # Remove common Perl files we don't package
575 %__spec_install_post_perl_clean {\
576 %{!?no_install_post_perl_clean: \
577 %{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
578 } }
579
580 #-----------------------------------------------------------------
581 # Update GConf2 schemas
582 #
583 # Requires: GConf2
584 #
585 %gconf_schema_install() \
586         umask 022; \
587         GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
588         /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null; \
589 %{nil}
590
591 %gconf_schema_uninstall() \
592 if [ $1 = 0 -a -x /usr/bin/gconftool-2 ]; then \
593         umask 022; \
594         GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" \\\
595         /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
596 fi; \
597 %{nil}
598
599 #-----------------------------------------------------------------
600 # Update desktop MIME database
601 # requires: desktop-file-utils
602 %update_desktop_database() {{ \
603         umask 022; \
604         /usr/bin/update-desktop-database -q; \
605 };} \
606 %{nil}
607
608 %update_desktop_database_post %update_desktop_database
609
610 %update_desktop_database_postun() {{ \
611 if [ "$1" = "0" ]; then \
612         %update_desktop_database \
613 fi; \
614 };} \
615 %{nil}
616
617 #-----------------------------------------------------------------
618 # Update shared MIME info database
619 # requires: shared-mime-info
620 #
621 %update_mime_database() {{ \
622         umask 022; \
623         /usr/bin/update-mime-database %{_datadir}/mime; \
624 };} \
625 %{nil}
626
627 #-----------------------------------------------------------------
628 # Update icon cache
629 # requires: gtk+
630 #
631 %update_icon_cache() {{ \
632         umask 022; \
633         /usr/bin/gtk-update-icon-cache -qf %{_datadir}/icons/%1; \
634 };} \
635 %{nil}
636
637 #-----------------------------------------------------------------
638 # Update scrollkeeper database
639 # requires: scrollkeeper
640 #
641 %scrollkeeper_update_post() \
642         /usr/bin/scrollkeeper-update -q; \
643 %{nil}
644
645 %scrollkeeper_update_postun() \
646 if [ "$1" = "0" ]; then \
647         /usr/bin/scrollkeeper-update -q; \
648 fi; \
649 %{nil}
650
651 #-----------------------------------------------------------------
652 # post %install sequence:
653 # - autodeps exceptions
654 # - compress all man and info pages,
655 # - strip all ELF executables and ELF shared objects if not %debug.
656 # - compress kernel modules if any
657
658 ###################################################################
659 # Requires/Provides automation
660 # exceptions system by Jacek Konieczny <jajcus@pld-linux.org>
661 #
662 %__noautoreqfiles       %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
663 %__noautoprovfiles      %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
664 %__noautoreq            %(sed -e s'/#.*//' /etc/rpm/noautoreq)%{?_noautoreq: %{_noautoreq}}
665 %__noautoreqdep         %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
666 %__noautoprov           %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
667
668 #%_noautocompressdoc    %{nil}
669 #
670 %_missing_doc_files_terminate_build     1%{nil}
671 %_unpackaged_files_terminate_build      %{nil}
672 # (X)emacs support
673 %___emacs_lispdir_helper  -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
674 %_emacs_lispdir %{expand:%%global _emacs_lispdir %(Z=$(emacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_emacs_lispdir
675 %_xemacs_lispdir %{expand:%%global _xemacs_lispdir %(Z=$(xemacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_xemacs_lispdir
676
677 %__php_provides %{nil}
678 %__php_requires %{nil}
679 %__perl_provides %{nil}
680 %__perl_requires %{nil}
681 %__mono_provides %{nil}
682 %__mono_requires %{nil}
683
684 # Perl specific macro definitions.
685 %perl_privlib           %{expand:%%global perl_privlib %(eval $(%{__perl} -V:installprivlib 2>/dev/null); echo ${installprivlib:-ERROR})}%perl_privlib
686 %perl_archlib           %{expand:%%global perl_archlib %(eval $(%{__perl} -V:installarchlib 2>/dev/null); echo ${installarchlib:-ERROR})}%perl_archlib
687 %perl_vendorlib         %{expand:%%global perl_vendorlib %(eval $(%{__perl} -V:installvendorlib 2>/dev/null); echo ${installvendorlib:-ERROR})}%perl_vendorlib
688 %perl_vendorarch        %{expand:%%global perl_vendorarch %(eval $(%{__perl} -V:installvendorarch 2>/dev/null); echo ${installvendorarch:-ERROR})}%perl_vendorarch
689 %perl_sitelib           %{expand:%%global perl_sitelib %(eval $(%{__perl} -V:installsitelib 2>/dev/null); echo ${installsitelib:-ERROR})}%perl_sitelib
690 %perl_sitearch          %{expand:%%global perl_sitearch %(eval $(%{__perl} -V:installsitearch 2>/dev/null); echo ${installsitearch:-ERROR})}%perl_sitearch
691
692 # Ruby
693 %__ruby                         /usr/bin/ruby
694 %ruby_archdir           %{expand:%%global ruby_archdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["archdir"]' 2>/dev/null || echo ERROR)}%ruby_archdir
695 %ruby_ridir                     %{expand:%%global ruby_ridir %(%{__ruby} -r rbconfig -e 'include Config; print File.join(CONFIG["datadir"], "ri", CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)}%ruby_ridir
696 %ruby_rubylibdir        %{expand:%%global ruby_rubylibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)}%ruby_rubylibdir
697 %ruby_vendorarchdir     %{expand:%%global ruby_vendorarchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorarchdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorarchdir
698 %ruby_vendorlibdir      %{expand:%%global ruby_vendorlibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorlibdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorlibdir
699 %ruby_sitearchdir       %{expand:%%global ruby_sitearchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitearchdir"]' 2>/dev/null || echo ERROR)}%ruby_sitearchdir
700 %ruby_sitelibdir        %{expand:%%global ruby_sitelibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitelibdir"]' 2>/dev/null || echo ERROR)}%ruby_sitelibdir
701 %ruby_rdocdir           /usr/share/rdoc
702 %ruby_version           %{expand:%%global ruby_version %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["ruby_version"]' 2>/dev/null || echo ERROR)}%ruby_version
703 %ruby_ver_requires_eq   Requires:       ruby(ver) = %ruby_version
704 %ruby_mod_ver_requires_eq       Requires:       ruby-modules(ver) = %ruby_version
705
706 %php_pear_dir           /usr/share/pear
707 %php_data_dir           /usr/share/php
708 %php_extensiondir       %{expand:%%global php_extensiondir %(php-config --extension-dir 2>/dev/null || echo ERROR)}%php_extensiondir
709 %php_sysconfdir         %{expand:%%global php_sysconfdir %(php-config --sysconfdir 2>/dev/null || echo ERROR)}%php_sysconfdir
710 %php_includedir         %{expand:%%global php_includedir %(php-config --include-dir 2>/dev/null || echo ERROR)}%php_includedir
711
712 # extract php/zend api versions
713 %php_major_version              %{expand:%%global php_major_version %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_major_version
714 %php_api_version                %{expand:%%global php_api_version %(awk '/#define PHP_API_VERSION/{print $3}' %{php_includedir}/main/php.h 2>/dev/null || echo ERROR)}%php_api_version
715 %php_pdo_api_version    %{expand:%%global php_pdo_api_version %(awk '/#define PDO_DRIVER_API/{print $3}' %{php_includedir}/ext/pdo/php_pdo_driver.h 2>/dev/null || echo ERROR)}%php_pdo_api_version
716 %php_debug                              %{expand:%%global php_debug %(awk '/#define ZEND_DEBUG/{print $3}' %{php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)}%php_debug
717 %zend_module_api                %{expand:%%global zend_module_api %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)}%zend_module_api
718 %zend_extension_api             %{expand:%%global zend_extension_api %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)}%zend_extension_api
719 %zend_zts                               %{expand:%%global zend_zts %(Z=$(grep -sc '^#define ZTS 1' %{php_includedir}/main/php_config.h); echo ${Z:-ERROR})}%zend_zts
720
721 # helper macro
722 %__php_api_requires(v:) Requires: php%{-v*}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
723
724 # macros for public use
725 # for php extensions (php-pecl)
726 %requires_php_extension %{__php_api_requires modules_api php_api_version} \
727 %{__php_api_requires zend_module_api} \
728 %{__php_api_requires -v %php_major_version debug php_debug} \
729 %{__php_api_requires -v %php_major_version thread-safety zend_zts}
730
731 # for zend extensions
732 %requires_zend_extension %{__php_api_requires zend_module_api} \
733 %{__php_api_requires zend_extension_api} \
734 %{__php_api_requires -v %php_major_version debug php_debug} \
735 %{__php_api_requires -v %php_major_version thread-safety zend_zts}
736
737 # for php pdo modules (php-pecl-PDO_*)
738 %requires_php_pdo_module %{__php_api_requires PDO_API php_pdo_api_version}
739
740 # for using PHP post scripts. for PHP >= 5.0
741 %php_webserver_restart \
742 [ ! -f /etc/apache/conf.d/??_mod_php.conf ] || %service -q apache restart \
743 [ ! -f /etc/httpd/conf.d/??_mod_php.conf ] || %service -q httpd restart \
744 if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
745         PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
746         if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php.fcgi* ]]; then \
747                 %service -q php-fcgi restart \
748         fi \
749 fi \
750 %{nil}
751
752 # for using php post scripts. for PHP >= 4.0 && PHP < 5.0
753 %php4_webserver_restart \
754 [ ! -f /etc/apache/conf.d/??_mod_php4.conf ] || %service -q apache restart \
755 [ ! -f /etc/httpd/conf.d/??_mod_php4.conf ] || %service -q httpd restart \
756 if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
757         PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
758         if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php4.fcgi* ]]; then \
759                 %service -q php-fcgi restart \
760         fi \
761 fi \
762 %{nil}
763
764 # X.org helper macros
765 %__xorg_abi_requires_ge() Requires: xorg-xserver-server(%{expand:%1}-abi) >= %{expand:%{%2}}
766 %__xorg_abi_requires_lt() Requires: xorg-xserver-server(%{expand:%1}-abi) < %(awk -vv=%{expand:%{%2}} 'BEGIN{split(v, a, "."); printf("%s.0", a[1] + 1); exit}')
767
768 %xorg_xserver_ansic_abi         %{expand:%%global xorg_xserver_ansic_abi %(awk '/#define ABI_ANSIC_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_ansic_abi
769 %xorg_xserver_extension_abi     %{expand:%%global xorg_xserver_extension_abi %(awk '/#define ABI_EXTENSION_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_extension_abi
770 %xorg_xserver_font_abi          %{expand:%%global xorg_xserver_font_abi %(awk '/#define ABI_FONT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null | echo ERROR)}%xorg_xserver_font_abi
771 %xorg_xserver_videodrv_abi      %{expand:%%global xorg_xserver_videodrv_abi %(awk '/#define ABI_VIDEODRV_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_videodrv_abi
772 %xorg_xserver_xinput_abi        %{expand:%%global xorg_xserver_xinput_abi %(awk '/#define ABI_XINPUT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_xinput_abi
773
774 %requires_xorg_xserver_extension \
775 %{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
776 %{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
777 %{__xorg_abi_requires_ge extension xorg_xserver_extension_abi} \
778 %{__xorg_abi_requires_lt extension xorg_xserver_extension_abi} \
779 %{nil}
780
781 %requires_xorg_xserver_xinput \
782 %{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
783 %{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
784 %{__xorg_abi_requires_ge xinput xorg_xserver_xinput_abi} \
785 %{__xorg_abi_requires_lt xinput xorg_xserver_xinput_abi} \
786 %{nil}
787
788 %requires_xorg_xserver_font \
789 %{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
790 %{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
791 %{__xorg_abi_requires_ge font xorg_xserver_font_abi} \
792 %{__xorg_abi_requires_lt font xorg_xserver_font_abi} \
793 %{nil}
794
795 %requires_xorg_xserver_videodrv \
796 %{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
797 %{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
798 %{__xorg_abi_requires_ge videodrv xorg_xserver_videodrv_abi} \
799 %{__xorg_abi_requires_lt videodrv xorg_xserver_videodrv_abi} \
800 %{nil}
801
802 # Python specific macro definitions.
803 # python main version
804 %py_ver                 %{expand:%%global py_ver %(%{__python} -c "import sys; print sys.version[:3]" 2>/dev/null || echo ERROR)}%py_ver
805
806 # directories
807 %py_prefix              %{expand:%%global py_prefix %(%{__python} -c "import sys; print sys.prefix" 2>/dev/null || echo ERROR)}%py_prefix
808 %py_libdir              %{py_prefix}/%{_lib}/python%{py_ver}
809 %py_scriptdir   %{py_prefix}/share/python%{py_ver}
810 %py_incdir              /usr/include/python%{py_ver}
811 %py_sitedir             %{py_libdir}/site-packages
812 %py_sitescriptdir %{py_scriptdir}/site-packages
813 %py_dyndir              %{py_libdir}/lib-dynload
814
815 # pure python modules compilation
816 %py_comp                python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
817
818 %py_ocomp               python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
819
820 # Software written in Python language require Python with main version
821 %pyrequires_eq() Requires:      %1
822
823 # Python 3.x
824 # python main version
825 %__python3                      python3.0
826 %py3_ver                        %{expand:%%global py3_ver %(%{__python3} -c "import sys; print(sys.version[:3])" 2>/dev/null || echo ERROR)}%py3_ver
827
828 # directories
829 %py3_prefix             %{expand:%%global py3_prefix %(%{__python3} -c "import sys; print(sys.prefix)" 2>/dev/null || echo ERROR)}%py3_prefix
830 %py3_libdir             %{py3_prefix}/%{_lib}/python%{py3_ver}
831 %py3_scriptdir  %{py3_prefix}/share/python%{py3_ver}
832 %py3_incdir             /usr/include/python%{py3_ver}
833 %py3_sitedir            %{py3_libdir}/site-packages
834 %py3_sitescriptdir %{py3_scriptdir}/site-packages
835 %py3_dyndir             %{py3_libdir}/lib-dynload
836
837 # pure python modules compilation
838 %py3_comp               %{__python3} -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
839
840 %py3_ocomp              %{__python3} -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
841
842 # Hardlink binary identical .pyc and .pyo files
843 %__spec_install_post_py_hardlink {\
844 %{!?no_install_post_py_hardlink: __spec_install_post_py_hardlink() { \
845 local a b c=0 t=0; \
846 if [ -d "$RPM_BUILD_ROOT" ]; then \
847         find "$RPM_BUILD_ROOT" -name '*.pyc' > __rpm_pyc; \
848         while read a; do \
849                 b="${a%.pyc}.pyo"; \
850                 if cmp -s "$a" "$b"; then \
851                         ln -f "$a" "$b"; \
852                         c=$((c + 1)); \
853                 fi; \
854                 t=$((t + 1)); \
855         done < __rpm_pyc; \
856         [ $t -gt 0 ] && printf "Hardlink Python files: %d/%d files hardlinked\n" $c $t; \
857         rm -f __rpm_pyc; \
858 fi; \
859 }; __spec_install_post_py_hardlink } }
860
861 # remove python sources, so that check-files won't complain
862 %py_postclean() \
863 for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
864  [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
865 done \
866 %{nil}
867
868 %py3_postclean() \
869 for d in %{py3_sitescriptdir} %{py3_sitedir} %*; do \
870  [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
871 done \
872 %{nil}
873
874 # depmod macro
875 %depmod() { \
876 umask 022; \
877 if [ -e /boot/System.map-%1 ]; then \
878         /sbin/depmod -a -F /boot/System.map-%1 %1; \
879 else \
880         if [ -e /boot/System.map ]; then \
881                 /sbin/depmod -a -F /boot/System.map %1; \
882         else \
883                 /sbin/depmod -a %1; \
884         fi \
885 fi; \
886 }
887
888 # XMMS specific macros
889 %xmms_prefix                    %{expand:%%global xmms_prefix %(xmms-config --prefix 2>/dev/null || echo ERROR)}%xmms_prefix
890 %xmms_exec_prefix               %{expand:%%global xmms_exec_prefix %(xmms-config --exec-prefix 2>/dev/null || echo ERROR)}%xmms_exec_prefix
891 %xmms_version                   %{expand:%%global xmms_version %(xmms-config --version 2>/dev/null || echo ERROR)}%xmms_version
892 %xmms_datadir                   %{expand:%%global xmms_datadir %(xmms-config --data-dir 2>/dev/null || echo ERROR)}%xmms_datadir
893 %xmms_plugindir                 %{expand:%%global xmms_plugindir %(xmms-config --plugin-dir 2>/dev/null || echo ERROR)}%xmms_plugindir
894 %xmms_visualization_plugindir   %{expand:%%global xmms_visualization_plugindir %(xmms-config --visualization-plugin-dir 2>/dev/null || echo ERROR)}%xmms_visualization_plugindir
895 %xmms_input_plugindir           %{expand:%%global xmms_input_plugindir %(xmms-config --input-plugin-dir 2>/dev/null || echo ERROR)}%xmms_input_plugindir
896 %xmms_output_plugindir          %{expand:%%global xmms_output_plugindir %(xmms-config --output-plugin-dir 2>/dev/null || echo ERROR)}%xmms_output_plugindir
897 %xmms_effect_plugindir          %{expand:%%global xmms_effect_plugindir %(xmms-config --effect-plugin-dir 2>/dev/null || echo ERROR)}%xmms_effect_plugindir
898 %xmms_general_plugindir         %{expand:%%global xmms_general_plugindir %(xmms-config --general-plugin-dir 2>/dev/null || echo ERROR)}%xmms_general_plugindir
899
900 %_target_base_arch      %{expand:%%global _target_base_arch %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/')}%_target_base_arch
901
902 # user/group checking macros
903 #
904 # Usage:
905 #       %userremove myuser
906 #
907 %userremove     /usr/lib/rpm/user_group.sh user del
908 %groupremove    /usr/lib/rpm/user_group.sh group del
909 #
910 # Usage:
911 #       if %usertestrm myuser; then
912 #               /usr/sbin/userdel -r myuser
913 # Note:
914 #       use these macros only if you need to call userdel/groupdel with
915 #       a non-standard option or take an extra action; otherwise use the
916 #       %userremove/%groupremove macros
917 #
918 %usertestrm     /usr/lib/rpm/user_group.sh user testrm
919 %grouptestrm    /usr/lib/rpm/user_group.sh group testrm
920 # user group membership management macros
921 #
922 # Usage:
923 #       %addusertogroup myuser agroup
924 #
925 %addusertogroup /usr/lib/rpm/user_group.sh user addtogroup
926
927 # banner support (useful in {pre,post}{,un} and triggers)
928 #
929 # Usage:
930 #       %banner name [-a] [-e] [-n] [-tn] <<EOF
931 # the banner text, the banner text
932 # the banner text, and following line
933 #EOF
934 # You can use any form of here-document, <<'EOF' <<-EOT will do.
935 # NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
936 #
937 # -a   - append to the banner
938 # -e   - send to stderr instead of stdout
939 # -n   - no show banner (overrides -t)
940 # -t   - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
941 #
942 # Tests:
943 # (rpm -E '%banner -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
944 # rpm -E 'date | %banner -e banner' > m; sh -x m
945 #
946 %banner(aent:) ( \
947 RPM_SCRIPTVERBOSITY=5 \
948 [ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
949 if [ -x /usr/bin/banner.sh ]; then \
950         CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
951 else \
952         CMD="cat%{-e: >&2}" \
953 fi \
954 eval $CMD %{?2:%2}%{?3: %3}) \
955 %{nil}
956
957 # useradd/groupadd macros
958 # Author: Elan Ruusamäe <glen@pld-linux.org>
959 #
960 # Usage:
961 #   %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
962 #   [-g initial_group] [-G group[,...]] login
963 #
964 #  -u uid. REQUIRED
965 #  -g gid/group. REQUIRED
966 #  -s defaults to /bin/false
967 #  -d defaults to /usr/share/empty
968 #  -c No default
969 #  -r is accepted but ignored (it's always set)
970 #  -k skeleton dir. defaults to /usr/share/empty
971 # rpm specific flags
972 #  -P package name. defaults to %{name}
973 #
974 %useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
975 %{!-u:%{error:useradd: Required argument -u missing}} \
976 %{!-g:%{error:useradd: Required argument -g missing}} \
977 %{!?1:%{error:useradd: Required parameter login missing}} \
978 if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
979         if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
980                 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
981                 exit 1 \
982         fi \
983 else \
984         echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
985         /usr/sbin/useradd \\\
986                 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
987                 -u %{-u*} \\\
988                 -r \\\
989                 -d %{-d*}%{!-d:/usr/share/empty} \\\
990                 -s %{-s*}%{!-s:/bin/false} \\\
991                 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
992                 -g %{-g*} \\\
993                 %{-M} \\\
994                 %{-G:-G %{-G*}} \\\
995                 %{expand:%{%{#}}} 1>&2 || exit $? \
996         [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
997 fi;
998
999 # Usage:
1000 #   %groupadd [-P package] [-g gid] group
1001 #
1002 # -g gid. REQUIRED
1003 #
1004 # Sample:
1005 #   %groupadd -P %{name}-base -g %{gid} %{name}
1006
1007 %groupadd(g:P:rfo)      \
1008 %{!-g:%{error:groupadd: Required argument -g missing}} \
1009 %{!?1:%{error:groupadd: Required parameter group missing}} \
1010 if /usr/bin/getgid %{1} > /dev/null 2>&1; then \
1011         if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
1012                 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
1013                 exit 1 \
1014         fi \
1015 else \
1016         echo "Adding group %{1} GID=%{-g*}." \
1017         /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
1018         [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
1019 fi;
1020
1021 # webapp macros
1022 # Author: Elan Ruusamäe <glen@pld-linux.org>
1023 #
1024 # The config is installed/removed inside trigger, this means that you can any
1025 # time install apache1/apache/lighttpd package and the configuration file is
1026 # updated. if you don't need the config for various reason for specific
1027 # webserver, just remove the symlink from config directory using webapp
1028 # program. the trigger will not recreate the symlink on upgrades. In other
1029 # words the config is linked to webserver config directory on first install of
1030 # PACKAGE or WEBSERVER.
1031 #
1032 # Add package's webserver config to webserver webapps dir.
1033 # Usage:
1034 #   %webapp_register WEBSERVER WEBAPP
1035 #
1036 %webapp_register() \
1037 %{?debug:set -x; echo "webapp_register: %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
1038 if [ "$1" = "1" ] && [ "$2" = "1" ]; then\
1039         /usr/sbin/webapp register %1 %2\
1040 fi\
1041 # reload webserver if the config symlink is there and skip reload if webserver is upgraded\
1042 if [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ] && [ "$2" -lt "2" ]; then\
1043         %{expand:%service -q %%1 reload}\
1044 fi\
1045 %{nil}
1046
1047 # Remove package's config from webserver webapps dir.
1048 # Usage:
1049 #   %webapp_register [-f] WEBSERVER WEBAPP
1050 %webapp_unregister(f) \
1051 %{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
1052 # remove link if either of the packages are gone \
1053 if [ -n "%{-f:1}" ] || [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ]; then \
1054         /usr/sbin/webapp unregister %1 %2\
1055         %{expand:%service -q %%1 reload}\
1056 fi \
1057 %{nil}
1058
1059 # service macro.
1060 # Author: Elan Ruusamäe <glen@pld-linux.org>
1061 #
1062 # calls usual service restart on package %post, but skips the restart if
1063 # administrator has disabled automatic service restarts in either global
1064 # /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
1065 #
1066 # Usage:
1067 #   %service [-q] [-n] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
1068 #
1069 #  -q be silent when service isn't started (for scriplets restaring other package's services)
1070 #  -n NOOP mode, do not actually restart service
1071 #
1072 # Requirements:
1073 # BuildRequires:        rpmbuild(macros) >= 1.268
1074 # Requires:     rc-scripts
1075 # -n option:
1076 # BuildRequires:        rpmbuild(macros) >= 1.450
1077 %service(qn) {{%(export noop=%{-n:1} quiet=%{-q:1}; /usr/lib/rpm/service_generator.sh %{*}) };}
1078
1079
1080 # Java macros. based on jpackage macros.java
1081 #
1082 # Root directory where all Java VMs/SDK/JREs are installed.
1083 %_jvmdir                %{_libdir}/jvm
1084
1085 # Root directory where all Java VMs/SDK/JREs expose their jars
1086 %_jvmjardir             %{_libdir}/jvm-exports
1087
1088 # Root directory for all Java VM/SDK/JRE's private things.
1089 %_jvmprivdir    %{_libdir}/jvm-private
1090
1091 # Root directory for all architecture dependent parts of Java VM/SDK/JRE's
1092 %_jvmlibdir             %{_libdir}/jvm
1093
1094 # Root directory for all architecture independent parts of Java VM/SDK/JRE's
1095 %_jvmdatadir    %{_datadir}/jvm
1096
1097 # Root directory for all configurations parts of Java VM/SDK/JRE's
1098 %_jvmsysconfdir %{_sysconfdir}/jvm
1099
1100 # Root directory for all common architecture dependent parts of Java VM/SDK/JRE's
1101 %_jvmcommonlibdir       %{_libdir}/jvm-common
1102
1103 # Root directory for all common architecture independent parts of Java VM/SDK/JRE's
1104 %_jvmcommondatadir      %{_datadir}/jvm-common
1105
1106 # Root directory for all common configurations parts of Java VM/SDK/JRE's
1107 %_jvmcommonsysconfdir   %{_sysconfdir}/jvm-common
1108
1109 # Directory where arch-specific (JNI) version-independent jars are installed.
1110 %_jnidir                %{_libdir}/java
1111
1112 %java_home              %{expand:%%global java_home %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVA_HOME; . %{_javadir}-utils/java-functions; set_jvm; echo ${JAVA_HOME:-ERROR})}%java_home
1113
1114 %ant                    JAVA_HOME=%{java_home} CLASSPATH=$CLASSPATH ant
1115 %jar                    %{java_home}/bin/jar
1116 %java                   %{expand:%%global java %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVACMD; . %{_javadir}-utils/java-functions; set_javacmd; echo $JAVACMD)}%java
1117 %javac                  %{java_home}/bin/javac
1118 %javadoc                %{java_home}/bin/javadoc
1119
1120 %add_jvm_extension      JAVA_LIBDIR=%{buildroot}/%{_javadir}    %{_bindir}/jvmjar -l
1121
1122 %jpackage_script() \
1123 install -d $RPM_BUILD_ROOT%{_bindir}\
1124 cat > $RPM_BUILD_ROOT%{_bindir}/%5 << 'EOF' \
1125 #!/bin/sh\
1126 #\
1127 # %{name} script\
1128 # JPackage Project <http://www.jpackage.org/>\
1129 \
1130 # Source functions library\
1131 . %{_javadir}-utils/java-functions\
1132 \
1133 # Source system prefs\
1134 if [ -f %{_sysconfdir}/java/%{name}.conf ]; then\
1135     . %{_sysconfdir}/java/%{name}.conf\
1136 fi\
1137 \
1138 # Source user prefs\
1139 if [ -f $HOME/.%{name}rc ]; then\
1140     . $HOME/.%{name}rc\
1141 fi\
1142 \
1143 # Configuration\
1144 MAIN_CLASS=%1\
1145 BASE_FLAGS=%2\
1146 BASE_OPTIONS=%3\
1147 BASE_JARS="%(echo %4 | tr ':' ' ')"\
1148 \
1149 # Set parameters\
1150 set_jvm\
1151 set_classpath $BASE_JARS\
1152 set_flags $BASE_FLAGS\
1153 set_options $BASE_OPTIONS\
1154 \
1155 # Let's start\
1156 run "$@"\
1157 EOF
1158
1159 # jpackage 1.7
1160 # Directory for maven depmaps
1161 #
1162 %_mavendepmapdir /etc/maven
1163 %_mavendepmapfragdir /etc/maven/fragments
1164
1165 #
1166 # add_to_depmap adds an entry to the depmap. The arguments are:
1167 #
1168 # %1 the original groupid
1169 # %2 the original artifact id
1170 # %3 the version
1171 # %4 the new groupid
1172 # %5 the new artifactid
1173 #
1174
1175 %add_to_maven_depmap() \
1176 install -dm 755 $RPM_BUILD_ROOT/%{_mavendepmapfragdir}\
1177 cat >>$RPM_BUILD_ROOT/%{_mavendepmapfragdir}/%{name}<< EOF\
1178 <dependency>\
1179     <maven>\
1180         <groupId>%1</groupId>\
1181         <artifactId>%2</artifactId>\
1182         <version>%3</version>\
1183     </maven>\
1184     <jpp>\
1185         <groupId>%4</groupId>\
1186         <artifactId>%5</artifactId>\
1187         <version>%3</version>\
1188     </jpp>\
1189 </dependency>\
1190 \
1191 EOF\
1192 %{nil}
1193
1194 #==============================================================================
1195 #
1196 # update_maven_depmap updates the main maven depmap
1197 #
1198 %update_maven_depmap() \
1199 echo -e "<dependencies>\\n" > %{_mavendepmapdir}/maven2-depmap.xml\
1200 if [ -d %{_mavendepmapfragdir} ] && [ -n "`find %{_mavendepmapfragdir} -type f`" ]; then\
1201 cat %{_mavendepmapfragdir}/* >> %{_mavendepmapdir}/maven2-depmap.xml\
1202 fi\
1203 echo -e "</dependencies>\\n" >> %{_mavendepmapdir}/maven2-depmap.xml
1204
1205
1206 # PEAR install macros
1207 # Author: Elan Ruusamäe <glen@pld-linux.org>
1208 #
1209 # Usage:
1210 #       %%pear_package_setup ...
1211 #
1212 # -a #   - also unpack SOURCE#. for PEAR bootstrapping
1213 # -n FMT - create builddir with FMT, instead of default %%{_pearname}-%%{version}
1214 # -z     - unpack pear package and let pear use package.xml (not tarball) for install. for PEAR bootstrapping
1215 # -D     - pass -D to %setup (so the build dir is not removed)
1216 # -c     - register channel from local channel.xml file
1217 #
1218 # unpack PEAR package to %%{_builddir}/FMT. package is extracted with already
1219 # destination hierarchy. you should copy the tree to buildroot after
1220 # patching/reorganizing with %%pear_package_install.
1221 #
1222 # additionally BUILDROOT is stripped from files and files are converted to UNIX
1223 # line endings.
1224 #
1225 # the pear install process output is recorded to install.log, you should put it
1226 # to %%doc for later debug or just for information.
1227 #
1228 # additionally additional-packages.txt is produced if it was detected that the
1229 # package has optional dependencies. the file format is suitable of displaying
1230 # in %%post of a package. you should put this file to %%doc. noautocompressdoc is
1231 # automatically added for this file.
1232
1233
1234 # records install.log and transforms PEAR names to PLD Linux rpm package names.
1235 %__pear_install_log \
1236 tee install.log \
1237 # make post message of optional packages \
1238 grep 'can optionally use' install.log | sed -e 's,package "pear/,package "php-pear-,g;s,^pear/,php-pear-,;s,^pear/,php-pear-,;s,^channel://.*/,,' > optional-packages.txt \
1239 if [ -s optional-packages.txt ]; then \
1240         awk -F'"' '/use package/{print $2}' optional-packages.txt | sed -e "s,_,/,g;s,php-pear-, 'pear(,;s,$,.*)'," | tr -d '\\\n' > _noautoreq \
1241 else \
1242         rm -f optional-packages.txt \
1243 fi \
1244 %{nil}
1245
1246 # command invoking pear cli
1247 %__pear /usr/bin/pear
1248
1249 %pear_install(a:n:zD) \
1250 %__pear \\\
1251         -c %{builddir}/pearrc \\\
1252         -d doc_dir=/docs \\\
1253         -d temp_dir=/tmp \\\
1254         -d php_dir=%{-c:%{builddir}/}%{php_pear_dir} \\\
1255         -d bin_dir=%{_bindir} \\\
1256         -d data_dir=%{php_pear_dir}/data \\\
1257         -d test_dir=%{php_pear_dir}/tests \\\
1258         install \\\
1259         --packagingroot=%{builddir} \\\
1260         --offline \\\
1261         --nodeps \\\
1262         %{-f:--force} \\\
1263         %{!-z:%{S:%{-a*}%{!-a:0}}}%{-z:$_P} > .install.log || { c=$?; cat .install.log; exit $c; }; \
1264         %{-c:cp -a %{builddir}/%{builddir}/%{php_pear_dir} %{builddir}/%(dirname %{php_pear_dir}); rm -rf %{builddir}/%{builddir}; } \
1265 %{nil}
1266
1267 # The main macro.
1268 # using this macro will append optional-packages.txt to the nocompressdoc list
1269 # as it's displayed to user after package install. and adding additional gzip
1270 # dep is just waste ;)
1271 %pear_package_setup(a:n:zDc:) \
1272 %define srcdir %{-n*}%{!-n:%{_pearname}-%{version}} \
1273 %define builddir %{_builddir}/%{srcdir} \
1274 %setup -q -c -T %{-D:-D} -n %{srcdir} \
1275 %{-z:tar zxf %{S:0}; %{-a:tar zxf %{S:%{-a*}}}} \
1276 %{-z:_P=package2.xml; [ -f $_P ] || _P=package.xml; _N=%{srcdir}; mv $_P $_N; cd $_N} \
1277 %{-c:%{__pear} -c pearrc config-set php_dir %{builddir}/%{php_pear_dir}; %__pear -c %{builddir}/pearrc channel-add %{-c*}} \
1278 %pear_install \
1279 %{-z:cd ..} \
1280 cat %{-z:$_N/}.install.log | %__pear_install_log \
1281 \
1282 # undos sources \
1283 find -type f -print0 | xargs -0 sed -i -e 's,\\r$,,' \
1284 %{!?_noautocompressdoc:%global _noautocompressdoc %{nil}}%{expand:%%global _noautocompressdoc %{_noautocompressdoc} optional-packages.txt} \
1285 %{!?_noautoprov:%global _noautoprov %{nil}}%{expand:%%global _noautoprov %{_noautoprov} 'pear(tests/.*)'} \
1286 %{nil}
1287
1288 # Copies exctracted PEAR package structure and PEAR registry to buildroot.
1289 # Author: Elan Ruusamäe <glen@pld-linux.org>
1290 %pear_package_install() \
1291 cp -a ./%{php_pear_dir}/{.registry,*} $RPM_BUILD_ROOT%{php_pear_dir} \
1292 find $RPM_BUILD_ROOT%{php_pear_dir} '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v \
1293 # help the developer out a little: \
1294 if [ -f _noautoreq ]; then \
1295         echo "AutoReqdep detected:" \
1296         echo "_noautoreq $(cat _noautoreq)" \
1297 fi \
1298 %{nil}
1299
1300
1301 # Register OpenLDAP schema.
1302 # Author: Elan Ruusamäe <glen@pld-linux.org>
1303 #
1304 # Usage:
1305 #   %%openldap_schema_register [-d core,nis] %{schemadir}/horde.schema
1306 #
1307 #  -d specify dependant schemas, separated by comma
1308 #
1309 %openldap_schema_register(d:) \
1310 for schema in %*; do \
1311         if ! grep -q "$schema" /etc/openldap/slapd.conf; then \
1312                 %{__sed} -i -e " \
1313                         /^include.*local.schema/{ \
1314                                 iinclude\\t     $schema\
1315                         } \
1316                 " /etc/openldap/slapd.conf \
1317         fi \
1318 done \
1319 # enable dependant schemas \
1320 if [ "%{-d*}" ]; then \
1321         %{__sed} -i -e ' \
1322         /^#include.*\\(%(echo '%{-d*}' | %{__sed} -e 's/,/\\\\|/g')\\)\\.schema/{ \
1323                 s/^#// \
1324         }' /etc/openldap/slapd.conf \
1325 fi \
1326 %{nil}
1327
1328 # Unregister OpenLDAP schema.
1329 # Author: Elan Ruusamäe <glen@pld-linux.org>
1330 #
1331 # Usage:
1332 #   %%openldap_schema_unregister %{schemadir}/horde.schema
1333 #
1334 %openldap_schema_unregister() \
1335 for schema in %*; do \
1336         if grep -q "$schema" /etc/openldap/slapd.conf; then \
1337                 %{__sed} -i -e " \
1338                 /^include.*$(echo "$schema" | %{__sed} -e 's,/,\\\\/,g')/d \
1339                 # for symmetry it would be nice if we disable enabled schemas in post, \
1340                 # but we really can not do that, it would break something else. \
1341                 " /etc/openldap/slapd.conf \
1342         fi \
1343 done \
1344 %{nil}
1345
1346 %env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
1347
1348
1349 # Build modules for kernels 2.6
1350 # Author: Przemyslaw Iskra <sparky@pld-linux.org>
1351 #
1352 # Usage:
1353 #       %build_kernel_modules -m <modules> -C <directory>
1354 #
1355 #  remember that proper Makefile is still required
1356 # Options:
1357 #  -m <modules> (required) -- comma-separated list of modules to save,
1358 #               without .ko extension, may be placed in subdirectory
1359 #  -C <directory> -- change to <directory> before doing anything
1360 #  -p <arg>, -P <arg> -- arguments passeed to make scripts
1361 #  -c -- do not execute make clean
1362 #  <additional arguments> -- all additional arguments will be passed to
1363 #               make modules
1364 #
1365 # Additional patching supported via here document. Try:
1366 #       %build_kernel_modules -m module <<'EOF'
1367 #       your patch script here
1368 #       EOF
1369 # Don't use it unless patching depends on config options.
1370
1371 # Developer note: don't touch it unless you know how to handle '\'.
1372 # - \ in script expands to nothing
1373 # - \\\ in script expands to \
1374 # - \\\ inside definition expands to nothing
1375 # - \\\\\\\ inside definition expands to \
1376 # - in last line \ has to touch arguments so arguments passing
1377 #   in new lines (using \) will be supported
1378
1379 %build_kernel_modules(p:P:m:C:c)                                                                        \
1380 %{!?-m:%{error:%{0}: Required module name/list missing} exit 1}         \
1381                                                                                                                                         \
1382 %define Opts                                                                                                            \\\\\\\
1383 %if "%{_target_base_arch}" != "%{_arch}"                                                        \\\
1384         %if "%{_arch}" == "x86_64" && "%{_target_base_arch}" == "i386"  \\\
1385         CC="%{kgcc}" ARCH=%{_target_base_arch}                                                  \\\
1386         %else                                                                                                                   \\\
1387         ARCH=%{_target_base_arch} CROSS_COMPILE=%{_target_cpu}-pld-linux- \\\
1388         %endif                                                                                                                  \\\
1389 %else                                                                                                                           \\\
1390         CC="%{kgcc}"                                                                                                    \\\
1391 %endif                                                                                                                          \
1392 %define MakeOpts HOSTCC="%{kgcc}" SYSSRC=%{_kernelsrcdir} SYSOUT=$PWD/o \\\\\\\
1393                 O=$PWD/o %{?with_verbose:V=1} %{Opts}                                           \
1394                                                                                                                                         \
1395 %{?-C:cd %{-C*}}                                                                                                        \
1396 compile() {                                                                                                                     \
1397         local L="<" PATCH_SH;                                                                                   \
1398         [[ '%{*}' != *$L$L* ]] || PATCH_SH="set -x -e;$(cat)"                   \
1399         set -e -x                                                                                                               \
1400         local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
1401                                                                                                                                         \
1402 for cfg in ${cfgs:-dist}; do                                        \
1403         [ -r "%{_kernelsrcdir}/config-$cfg" ] || exit 1                                 \
1404                                                                                                                                         \
1405         rm -rf o                                                                                                                \
1406         install -d o/include/linux o/arch/powerpc/lib                                   \
1407         ln -sf %{_kernelsrcdir}/config-$cfg o/.config                                   \
1408         ln -sf %{_kernelsrcdir}/Module.symvers-$cfg o/Module.symvers    \
1409         ln -sf %{_kernelsrcdir}/include/linux/autoconf-$cfg.h o/include/linux/autoconf.h \
1410                                                                                                                                         \
1411         set +x                                                                                                                  \
1412         [ -z "$PATCH_SH" ] || echo "$PATCH_SH" | %__spec_build_shell    \
1413         set -x                                                                                                                  \
1414                                                                                                                                         \
1415         %if %{with dist_kernel} || %(test -f %{_kernelsrcdir}/scripts/bin2c ; echo $?)  \
1416                 %{__make} -j1 -C %{_kernelsrcdir} prepare scripts                       \\\
1417                         %{-p*} %{-P*}                                                                                   \\\
1418                         %{MakeOpts}                                                                                             \
1419         %else                                                                                                                   \
1420                 install -d o/include/config                                                                     \
1421                 touch o/include/config/MARKER                                                           \
1422                 ln -sf %{_kernelsrcdir}/include/config/auto-$cfg.conf o/include/config/auto.conf        \
1423                 ln -sf %{_kernelsrcdir}/scripts o/scripts                                       \
1424         %endif                                                                                                                  \
1425                                                                                                                                         \
1426         %{!?-c:%{__make} -C %{_kernelsrcdir} clean                                              \\\
1427                 RCS_FIND_IGNORE="-name '*.ko' -o"                                                       \\\
1428                 ${1+"$@"}                                                                                                       \\\
1429                 M=$PWD %{MakeOpts}}                                                                                     \
1430                                                                                                                                         \
1431         %{__make} -C %{_kernelsrcdir} modules                                                   \\\
1432                 ${1+"$@"}                                                                                                       \\\
1433                 M=$PWD %{MakeOpts}                                                                                      \
1434                                                                                                                                         \
1435         for MODULE in {%{-m*},}; do                                                                             \
1436                 [ -z "${MODULE}" ] || mv ${MODULE}{,-$cfg}.ko                           \
1437         done                                                                                                                    \
1438 done                                                                                                                            \
1439 %{?-C:cd -}                                                                                                                     \
1440 }                                                                                                                                       \
1441 compile %{*}\
1442 %{nil}
1443
1444
1445 # Install kernel modules built by %build_kernel_modules
1446 # Author: Przemyslaw Iskra <sparky@pld-linux.org>
1447 #
1448 # Usage:
1449 #       %install_kernel_modules -m <modules> -d <directory>
1450 #
1451 # Options:
1452 #  -m <modules> (required) -- comma-separated list of modules to install,
1453 #               without .ko extension, may be placed in subdirectory
1454 #  -d <directory> (required) -- in what subdirectory modules should be
1455 #               installed (eg. misc, kernel/drivers/net)
1456 #  -s <suffix> -- suffix to use when installing modules, useful when module
1457 #               with same name exists in kernel already
1458 #  -n <file> -- name of modprobe config file to use (without .conf extension)
1459 #               for defining aliases, only useful with -s
1460
1461 %install_kernel_modules(m:d:s:n:)                                                                       \
1462 %{!?-m:%{error:%{0}: Required module name (-m) missing}exit 1}          \
1463 %{!?-d:%{error:%{0}: Required module directory missing}exit 1}          \
1464 %{?-n:%{!?-s:%{error:%{0}: Modprobe .conf file requires module suffix}exit 1}} \
1465                                                                                                                                         \
1466 %define KernelD $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver}                      \
1467 %define ModprobeD $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/%{_kernel_ver} \
1468                                                                                                                                         \
1469 __install_kernel_modules() {                                                                            \
1470 local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
1471                                                                                                                                         \
1472 for MODULE in {%{-m*},}; do                                                                                     \
1473         [ -n "${MODULE}" ] || continue                                                                  \
1474         for cfg in ${cfgs:-dist}; do                                    \
1475                 [ "$cfg" = smp ] && suf=smp || suf=                                                     \
1476                 MNAME=${MODULE##*/}                                                                                     \
1477                 install -D ${MODULE}-$cfg.ko                                                            \\\
1478                         %{KernelD}$suf/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko                  \
1479                 %{?-s:install -d %{ModprobeD}$suf                                                       \
1480                         echo "alias ${MNAME} ${MNAME}-%{-s*}"                                   \\\
1481                         >> %{ModprobeD}$suf/%{-n*}.conf}                                                \
1482         done                                                                                                                    \
1483 done                                                                                                                            \
1484 }                                                                                                                                       \
1485 __install_kernel_modules                                                                                        \
1486 %{nil}
1487
1488 # patchset macros
1489 # Author: Elan Ruusamäe <glen@pld-linux.org>
1490 #
1491 # Usage:
1492 #   %patchset_source -f <seq(1) format> <start> [<end>]
1493 #   %patchset_patch <start> [<end>]
1494 #
1495 # If <end> is omited, it is assumed to be <start>.
1496 #
1497 # For example in preamble:
1498 #  %patchset_source -f ftp://ftp.vim.org/pub/editors/vim/patches/7.0/7.0.%03g 33 44
1499 # and in %prep:
1500 #  %patchset_patch 33 44
1501
1502 # generate SourceX urls from range START STOP
1503 # Format can be SINGLE format char of %e, %f, %g, see seq(1)
1504 # The sources start from 10000
1505 %patchset_source(f:b:) %(
1506         base=%{-b*}%{!-b*:10000};
1507         start=$(expr $base + %1);
1508         end=$(expr $base + %{?2}%{!?2:%{1}});
1509         # we need to call seq twice as it doesn't allow two formats
1510         seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
1511         seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
1512         paste %{tmpdir}/__ps{1,2};
1513         rm -f %{tmpdir}/__ps{1,2};
1514 ) \
1515 %{nil}
1516
1517 # apply sources from %patchset_source
1518 # -p specify -pX for %patch line
1519 # -b base offset: defaults to 10000
1520 %patchset_patch(f:p:b:) %(
1521         base=%{-b*}%{!-b*:10000};
1522         start=$(expr $base + %1);
1523         end=$(expr $base + %{?2}%{!?2:%{1}});
1524         echo ": patchset_patch %1%{?2: to %2}";
1525         seq -f 'patch%g %{-p*:-p%{-p*}}' $start $end | sed -e s,^,%%,;
1526 ) \
1527 %{nil}
1528
1529 # browser plugins v2
1530 # Author: Elan Ruusamäe <glen@pld-linux.org>
1531 #
1532 # Usage:
1533 #       %browser_plugins_add_browser <name> -p <plugindir>
1534 #
1535 #  <name> (required) -- name of the browser. usually %{name}.
1536 #  -p <plugindir> (required) -- in what directory browser searches for its plugins.
1537 #  -b -- default blacklists
1538 #  -a <arch> override arch
1539 #
1540 # Example:
1541 #   %browser_plugins_add_browser %{name} -p %{_firefoxdir}/plugins
1542
1543 %_browserpluginsconfdir         /etc/browser-plugins
1544 %_browserpluginsdir                     %{_libdir}/browser-plugins
1545 %update_browser_plugins         /usr/sbin/update-browser-plugins || :
1546
1547 %browser_plugins_add_browser(p:b:a:) \
1548         browser=%1.%{!-a:%{_target_base_arch}}%{-a*} \
1549         install -d $RPM_BUILD_ROOT%{_browserpluginsconfdir}/{blacklist,browsers}.d \
1550         ln -s %{-p*} $RPM_BUILD_ROOT%{_browserpluginsconfdir}/browsers.d/$browser \
1551         blacklist_file=$RPM_BUILD_ROOT%{_browserpluginsconfdir}/blacklist.d/$browser.blacklist \
1552         echo '# This file format is shell globs at base dir of plugindir' > $blacklist_file \
1553         %{-b:cat >> $blacklist_file %{-b*}} \
1554 %{nil}
1555
1556 # Helper for LUA.
1557 # split string separated by space into quoted list
1558 #
1559 # Author: Elan Ruusamäe <glen@pld-linux.org>
1560 #
1561 # %__lua_split /bin/sh /bin/pdksh -> "/bin/sh", "/bin/pdksh"
1562 %__lua_split() %(echo "%*" | awk '{for (i=1;i<=NF;i++) printf("\\"%%s\\"%%s", $i, i == NF ? "" : ", ")}')
1563
1564 # adjust /etc/shells by adding and removing shells from there
1565 # Author: Elan Ruusamäe <glen@pld-linux.org>
1566 #
1567 # Usage:
1568 #   %post       -p <lua>
1569 #   %lua_add_etc_shells /bin/sh /bin/pdksh
1570 #
1571 #   %preun      -p <lua>
1572 #   if arg[2] == 0 then
1573 #       %lua_remove_etc_shells /bin/bash /bin/rbash
1574 #   end
1575 #
1576 # Requirements:
1577 # BuildRequires:        rpmbuild(macros) >= 1.462
1578 #
1579
1580 %lua_add_etc_shells() \
1581 t = {}\
1582 f = io.open("/etc/shells", "r")\
1583 if f then\
1584         for l in f:lines() do t[l]=l; end\
1585         f:close()\
1586 end\
1587 for _, s in ipairs({%{expand:%%__lua_split %*}}) do\
1588         if not t[s] then\
1589                 print("Adding "..s.." to /etc/shells")\
1590                 f = io.open("/etc/shells", "a"); f:write(s.."\\n"); f:close()\
1591         end\
1592 end\
1593 %{nil}
1594
1595 %lua_remove_etc_shells() \
1596 t = {}\
1597 f = io.open("/etc/shells", "r")\
1598 if f then\
1599         for l in f:lines() do t[l]=l; end\
1600         f:close()\
1601 end\
1602 for _, l in pairs({%{expand:%%__lua_split %*}}) do\
1603         print("Removing "..l.." from /etc/shells")\
1604         t[l] = nil\
1605 end\
1606 s=""\
1607 for _, l in pairs(t) do\
1608         s=s..l.."\\n"\
1609 end\
1610 io.open("/etc/shells", "w"):write(s)\
1611 %{nil}
1612
1613 # Backwards compat. Use of %lua_ prefixed macros is preferred as these are cleaner to read.
1614 #
1615 # Author: Elan Ruusamäe <glen@pld-linux.org>
1616 #
1617 # Usage:
1618 #   %post       -p %add_etc_shells -p /bin/sh /bin/pdksh
1619 #   %preun      -p %remove_etc_shells -p /bin/sh /bin/pdksh
1620 #
1621 #  -p (optional) -- specifies that result is embeded %post script (prepends <lua> as first line)
1622 #
1623 # Requirements:
1624 # BuildRequires:        rpmbuild(macros) >= 1.429
1625 #
1626 %add_etc_shells(p) %{-p:<lua>}\
1627 %{expand:%%lua_add_etc_shells %*}\
1628 %{nil}
1629
1630 %remove_etc_shells(p) %{-p:<lua>}\
1631 %{-p:if arg[2] == 0 then}\
1632 %{expand:%%lua_remove_etc_shells %*}\
1633 %{-p:end} \
1634 %{nil}
1635
1636 # Check syntax for Python files
1637 #
1638 # Author: Elan Ruusamäe <glen@pld-linux.org>
1639 # Author: Arkadiusz Miśkiewicz <arekm@pld-linux.org>
1640 #
1641 # Usage:
1642 #   %py_lint src
1643 #
1644 # Requirements:
1645 # BuildRequires:        python
1646 # BuildRequires:        rpmbuild(macros) >= 1.469
1647
1648 %py_lint() \
1649 __py_lint() { \
1650 find "$@" -type f -name '*.py' | python -c ' \
1651 import sys \
1652 import compiler \
1653 \
1654 err = 0\
1655 for f in sys.stdin: \
1656         fd = open(f.strip()) \
1657         c = fd.read() \
1658         fd.close() \
1659         try: \
1660                 compiler.parse(c) \
1661         except SyntaxError, e: \
1662                 print "py_lint: %s: %s" % (f.strip(), e) \
1663                 err = err + 1\
1664 \
1665 if err: \
1666         print >> sys.stderr, "\\npy_lint: ERROR: Syntax errors in %d files.\\n" % err \
1667         sys.exit(1) \
1668 else: \
1669         print >> sys.stderr,  "py_lint: Found no syntax errors." \
1670 ' \
1671 }; __py_lint %* \
1672 %{nil}
1673
1674 # vim:ts=4 sw=4 noet syn=spec
This page took 0.313111 seconds and 3 git commands to generate.